%%==============================================================================
%% Type definition for the Hook Settings data structure
%%==============================================================================
-module(bec_hook_settings_t).

%%==============================================================================
%% Exports
%%==============================================================================
-export([ from_map/1, to_map/1]).

-include("bitbucket.hrl").

%%==============================================================================
%% Types
%%==============================================================================
%% Settings are plugin-specific, so we keep the type definition general.
-type settings() :: map().

%%==============================================================================
%% Export Types
%%==============================================================================
-export_type([ settings/0
             ]).

%%==============================================================================
%% API
%%==============================================================================
-spec from_map(map()) -> settings().
from_map(Map) ->
  Map.

-spec to_map(settings()) -> map().
to_map(Settings) ->
  Settings.
